<!DOCTYPE html>

<html lang="en">
<head>
	<meta charset="utf-8">
	<meta name="viewport" content="width=device-width">
	<title>DocStrap Source: tool.dbpool.js</title>

	<!--[if lt IE 9]>
	<script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
	<![endif]-->
	<link type="text/css" rel="stylesheet" href="styles/sunlight.default.css">

	<link type="text/css" rel="stylesheet" href="styles/site.cosmo.css">

</head>

<body>

<div class="navbar navbar-default navbar-fixed-top navbar-inverse">
<div class="container">
	<div class="navbar-header">
		<a class="navbar-brand" href="index.html">DocStrap</a>
		<button class="navbar-toggle" type="button" data-toggle="collapse" data-target="#topNavigation">
			<span class="icon-bar"></span>
			<span class="icon-bar"></span>
			<span class="icon-bar"></span>
        </button>
	</div>
	<div class="navbar-collapse collapse" id="topNavigation">
		<ul class="nav navbar-nav">
			
			<li class="dropdown">
				<a href="classes.list.html" class="dropdown-toggle" data-toggle="dropdown">Classes<b class="caret"></b></a>
				<ul class="dropdown-menu ">
					<li><a href="DbPool.html">DbPool</a></li><li><a href="QueryBuilder.html">QueryBuilder</a></li>
				</ul>
			</li>
			
		</ul>
        
            <div class="col-sm-3 col-md-3">
                <form class="navbar-form" role="search">
                    <div class="input-group">
                        <input type="text" class="form-control" placeholder="Search" name="q" id="search-input">
                        <div class="input-group-btn">
                            <button class="btn btn-default" id="search-submit"><i class="glyphicon glyphicon-search"></i></button>
                        </div>
                    </div>
                </form>
            </div>
        
	</div>

</div>
</div>


<div class="container" id="toc-content">
<div class="row">

	
	<div class="col-md-12">
	
		<div id="main">
			

		<h1 class="page-title">Source: tool.dbpool.js</h1>
    
<section>
    <article>
        <pre
            class="sunlight-highlight-javascript linenums">const Pool = require('pg-pool');

/**
 * @description
 * Class used to launch query to database synchronously or not
 */
class DbPool{

    /**
     * @param {Object} dto
     * @param {string} dto.dbName - the database Name
     * @param {string} dto.dbUser - the database user
     * @param {string} dto.dbHost - the database host
     * @param {string} dto.dbPort - the database port
     * @param {string} dto.dbPassword - the database password
     * @param {number=} [dto.idleTimeoutMillis=60000] - the millisecond timeout before closing idle clients after 60000 second
     * @param {number=} [dto.connectionTimeoutMillis=60000] - the millisecond timeout before returning an error after 60000 second if connection could not be established
     */
    constructor(dto){
        this.pool = new Pool({
            user: dto.dbUser,
            database: dto.dbName,
            host: dto.dbHost,
            password: dto.dbPassword,
            port: dto.dbPort,
            idleTimeoutMillis: 60000,
            connectionTimeoutMillis: 60000,
        });
    }

    //region TIMEOUT SETTINGS
    /**
     * @description
     * Used to change default value of 1min before closing idle clients after #millisecond
     *
     * @param {number} millisecond - the millisecond timeout before closing idle clients after #millisecond
     *
     * @returns {DbPool}
     */
    maxClientTimeout(millisecond){

        if(typeof millisecond !== "number"){
            throw new Error(`
            ===================================
            The max timeout has to be an number
            ===================================
            `);
        }

        this.pool.options.idleTimeoutMillis = millisecond;

        return this;
    }

    /**
     * @description
     * Used to change default value of 1 min before returning an error if connection could not be established
     *
     * @param {number} millisecond - return an error after #millisecond second if connection could not be established
     *
     * @returns {DbPool}
     */
    maxConnectionTimeout(millisecond){

        if(typeof millisecond !== "number"){
            throw new Error(`
            ===================================
            The max timeout has to be an number
            ===================================
            `);
        }

        this.pool.options.connectionTimeoutMillis = millisecond;

        return this;
    }
    //endregionS

    //region EXECUTING FUNCTIONS
    /**
     * @description This allows to launch asynchronously query to the database.
     *
     * @param {string} query - the sql query to launch
     *
     * @return {Promise} - the promise result
     */
    launchAsynchQuery(query){

        return new Promise( (resolve, reject)=>{

            this.pool.connect()
                .then(Client =>{

                    Client.query(query)
                        .then(data =>{

                            Client.release();
                            resolve(data);
                        })
                        .catch(reject);
                })
                .catch(reject);
        });
    }

    /**
     * @description This allows to launch synchronously query to the database.
     *
     * @param {string} query - the sql query to launch
     *
     * @return {Promise} - the awaited "promise" result (data or error)
     */
    async launchSyncQuery(query){
        let error = `Error occurs while connecting or querying database`;
        let client;
        let data;

        try{

            client = await this.pool.connect();
            data = await client.query(query);

            return data;

        } catch(exception){

            console.error(`${error} with ecxeption: \n${exception}`);
            return error;

        } finally {

            if(client) client.release();
        }
    }
    //endregion
}

exports.dbpool = DbPool;</pre>
    </article>
</section>





		</div>
	</div>

	<div class="clearfix"></div>

	

</div>
</div>


    <div class="modal fade" id="searchResults">
      <div class="modal-dialog">
        <div class="modal-content">
          <div class="modal-header">
            <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
            <h4 class="modal-title">Search results</h4>
          </div>
          <div class="modal-body"></div>
          <div class="modal-footer">
            <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
          </div>
        </div><!-- /.modal-content -->
      </div><!-- /.modal-dialog -->
    </div>


<footer>


	<span class="copyright">
	DocStrap Copyright © 2012-2015 The contributors to the JSDoc3 and DocStrap projects.
	</span>

<span class="jsdoc-message">
	Documentation generated by <a href="https://github.com/jsdoc3/jsdoc">JSDoc 3.5.5</a>
	
		on Sun Oct 15th 2017
	
	using the <a href="https://github.com/docstrap/docstrap">DocStrap template</a>.
</span>
</footer>

<script src="scripts/docstrap.lib.js"></script>
<script src="scripts/toc.js"></script>

    <script type="text/javascript" src="scripts/fulltext-search-ui.js"></script>


<script>
$( function () {
	$( "[id*='$']" ).each( function () {
		var $this = $( this );

		$this.attr( "id", $this.attr( "id" ).replace( "$", "__" ) );
	} );

	$( ".tutorial-section pre, .readme-section pre, pre.prettyprint.source" ).each( function () {
		var $this = $( this );

		var example = $this.find( "code" );
		exampleText = example.html();
		var lang = /{@lang (.*?)}/.exec( exampleText );
		if ( lang && lang[1] ) {
			exampleText = exampleText.replace( lang[0], "" );
			example.html( exampleText );
			lang = lang[1];
		} else {
			var langClassMatch = example.parent()[0].className.match(/lang\-(\S+)/);
			lang = langClassMatch ? langClassMatch[1] : "javascript";
		}

		if ( lang ) {

			$this
			.addClass( "sunlight-highlight-" + lang )
			.addClass( "linenums" )
			.html( example.html() );

		}
	} );

	Sunlight.highlightAll( {
		lineNumbers : true,
		showMenu : true,
		enableDoclinks : true
	} );

	$.catchAnchorLinks( {
        navbarOffset: 10
	} );
	$( "#toc" ).toc( {
		anchorName  : function ( i, heading, prefix ) {
			return $( heading ).attr( "id" ) || ( prefix + i );
		},
		selectors   : "#toc-content h1,#toc-content h2,#toc-content h3,#toc-content h4",
		showAndHide : false,
		smoothScrolling: true
	} );

	$( "#main span[id^='toc']" ).addClass( "toc-shim" );
	$( '.dropdown-toggle' ).dropdown();

    $( "table" ).each( function () {
      var $this = $( this );
      $this.addClass('table');
    } );

} );
</script>



<!--Navigation and Symbol Display-->


<!--Google Analytics-->



    <script type="text/javascript">
        $(document).ready(function() {
            SearcherDisplay.init();
        });
    </script>


</body>
</html>
